<template>
  <!-- 搜索工作栏 -->
  <div class="bg-white px-2 py-2 rounded-sm">
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="分类名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入分类名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="分类状态" prop="status">
        <el-select
          v-model="queryParams.status"
          placeholder="请选择分类状态"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.COMMON_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['rq:iot-soc-source:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button type="danger" plain @click="toggleExpandAll">
          <Icon icon="ep:sort" class="mr-5px" /> 展开/折叠
        </el-button>
      </el-form-item>
    </el-form>
  </div>

  <!-- 列表 -->
  <ContentWrap style="border: none; margin-top: 20px">
    <zm-table
      :loading="loading"
      :data="list"
      row-key="id"
      :default-expand-all="isExpandAll"
      v-if="refreshTable"
      @row-click="handleClick"
    >
      <zm-table-column prop="name" label="分类名称" :show-overflow-tooltip="true" align="left" />
      <!--      <el-table-column prop="code" label="分类编码" />-->
      <zm-table-column prop="sort" label="排序" width="90" />
      <zm-table-column prop="status" label="状态" width="90" align="center">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status" />
        </template>
      </zm-table-column>
      <zm-table-column prop="remark" label="备注" />
      <zm-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        width="180"
        :formatter="dateFormatter"
      />
      <zm-table-column label="操作" align="center" action fixed="right" width="120">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['rq:iot-soc-source:update']"
          >
            修改
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['rq:iot-soc-source:delete']"
          >
            删除
          </el-button>
        </template>
      </zm-table-column>
    </zm-table>
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <ProductClassifyForm ref="formRef" @success="getList" />
</template>
<script lang="ts" setup>
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import { handleTree } from '@/utils/tree'
import { IotSocApi } from '@/api/pms/qhse/index'
import ProductClassifyForm from './SOCClassifyForm.vue'

defineOptions({ name: 'IotProductClassify' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref() // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 100,
  name: undefined,
  status: undefined
})
const queryFormRef = ref() // 搜索的表单
const isExpandAll = ref(true) // 是否展开，默认全部展开
const refreshTable = ref(true) // 重新渲染表格状态
const parentId = ref('')
const handleClick = (node: {}) => {
  parentId.value = node.id
}
/** 查询分类列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await IotSocApi.getSocList(queryParams)
    list.value = handleTree(data)
  } finally {
    loading.value = false
  }
}

/** 展开/折叠操作 */
const toggleExpandAll = () => {
  refreshTable.value = false
  isExpandAll.value = !isExpandAll.value
  nextTick(() => {
    refreshTable.value = true
  })
}

/** 搜索按钮操作 */
const handleQuery = () => {
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryParams.pageNo = 1
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number, parent: number) => {
  parent = parentId.value
  formRef.value.open(type, id, parent)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await IotSocApi.deleteSoc(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(async () => {
  await getList()
  // 获取用户列表
  //userList.value = await UserApi.getSimpleUserList()
})
</script>
<style scoped>
/* 全局样式或 scoped 穿透 */
:deep(.el-table__body tr) {
  cursor: pointer; /* 手型光标 */
}

:deep(.el-table__body tr:hover) {
  cursor: pointer;
}
</style>
